; ****************************************************************************
;	    FULL ZX81 CHESS IN 1K  -  (c) Copyright David Horne 1983
; ****************************************************************************
;
;     Based on an article from the February 1983 issue of 'Your Computer'.
;
; "The program is copyright. You can produce a copy of the program from the
;  listings for your own use, but you should not copy the listings or parts
;  thereof and offer for sale"

;#define QPawn			; choose this option for "Queen's pawn game"
;#define ShowCursor		; shows a cursor (inverse "?") in INPUT line
;#define ZX80upg		; choose this option for the upgraded ZX80
;#define FreeToUse		; it shows the max. program size (948 bytes) 

DECODE		.equ $07bd

	; system variables
	; ERR_NR,FLAGS,ERR_SP,RAMTOP,MODE,PPC (9 bytes)

oldScore .equ $4000
newScore .equ $4005  

	.org $4009		; 16393 

	.db $00			; VERSN
;
;	-------------------------------------------- free to use (2 bytes)
;
	.dw $0004		; E_PPC
;
;	------------------------------------------------------------------
;
	.dw DFile		; D_FILE
;
;	------------------------------------------- free to use (19 bytes)
;
	.dw $0000		; DF_CC
	.dw Variables		; VARS
	.dw $0000		; DEST
	.dw eof_Vars 		; E_LINE
	.dw eof_Vars+4		; CH_ADD
	.dw $0000		; X_PTR
	.dw $0000		; STKBOT
	.dw $0000		; STKEND
	.db $00			; BREG
	.dw $0000		; MEM
;
;	---------------------------------- UNUSED1, DF_SZ, S_TOP (4 bytes)
TKP
#ifdef ShowCursor
	ld (hl),$8F		; the cursor (inverse "?") character
#else
	push hl			; save input line position
TKP0
	push bc			; save possible character codes
#endif
	jr old_TKP		; the original subroutine 
;
;	------------------------------------------------------------------
;
LAST_K	.dw $0000		; LAST_K
	.db $00			; DEBOUN
	.db $00			; MARGIN
;
;	---------------- NXTLIN,OLDPPC,FLAGX,STRLEN,T_ADDR,SEED (11 bytes)
;
; TestList: tests to see if there are any moves in the move list.
;
TL				; "ld hl,newList"
	.dw Line3		; NXTLIN	-  autostart
				; last byte of "ld hl,newList"
	.db newList/256		; starting address of the list of moves
	dec (hl)		; lower the counter

TL1				;(FLAGX: the startup overwrites this byte)
	ld a,(hl)		; read the counter

	inc a			; if the original value is
	ret z			; zero, then back

TL2				;(T_ADDR: the startup overwrites these 2 bytes)
	add a,l			; otherwise set the pointer
	ld l,a			; to the last item

	ld a,(hl)		; return with the value of the last item
	ret			; 
;
;	------------------------------------------------------------------
;
	.dw $8001		; FRAMES
;
;	---------------------------------- COORDS, PR_CC, S_POSN (5 bytes)
;
#ifdef ZX80upg
GameOver
        ld bc,$0181             ; an unavailable graphic symbol
        jr old_TKP		;
#else
KYBD
	ld bc,$0826		; possible character codes ("A".."H")
	jr KYBD0
#endif
;
;	------------------------------------------------------------------
;
	.db $40			; CDFLAG	starts in SLOW mode
;
;	----------------------------------------- PRBUFF, MEMBOT, UNUNSED2
;
; The subroutine TKP just scans the keyboard waiting for an appropriate key to
; be depressed. The alpha-numeric entry is then translated to a board address.
;
old_TKP
#ifdef ShowCursor
	push hl			; save input line position
TKP0
	push bc			; save possible character codes
#endif
TKP1

#ifdef ZX80upg

	bit 6,(iy+$3b)		; is it an upgraded ZX80? (CDFLAG)
	call z,$0229		; -> FAST mode displaying (PAUSE)
#endif
        ld bc,(LAST_K)          ; the status of the keyboard

	inc c			; if non of the keys are pressed,
	jr z,TKP1		; then read again

        dec c                   ; set back the keyboard status
	call DECODE		; ROM: $07bd

	ld a,(hl)		; A= the decoded character
	pop bc			; set back the possible character 
	push bc			; codes for the test
TKP2
	cp c			; if it corresponds,
	jr z,TKP3		; return

	inc c			; next value
	djnz TKP2		; if it's not among the 8 possible

	pop bc			; value, 
	jr TKP0			; then start from the beginning
TKP3
	pop bc			; possible character codes
	pop hl			; input position (INPUT)
	ld (hl),a		; display the character
	ret     
;
;	------------------------------------------------------------------
;
; KYBD is a routine which sets up machine control of the keyboard such that only
; the eight key codes from code 29 and the eight key codes from code 38 are
; acceptable entries. Any other key depression is ignored.
;
#ifdef ZX80upg
KYBD
	ld bc,$0826		; possible character codes ("A".."H")
#endif
KYBD0
	call TKP		; reading the keyboard 

	inc hl			; next input position
	ld c,$1d		; possible character codes ("1".."8")
	call TKP		; reading the keyboard

	sub $1c			; number from character ("1" -> 1; "8" -> 8)
	ld b,a			; Y (rows)
	xor a			;
KYBD1
	add a,$0b		; 11*Y
	djnz KYBD1		;

	add a,CountA1 & 255	; ($61 originally)
	dec hl			; next input position (column)
	sub (hl)		; A= the screen position's lower byte 
;
;	------------------------------------------------------------------
;
; STR: this routine takes the board address and determines whether the contents
; are: different from the current mover colour (0); empty (1); the board
; surround (2) or the same colour as the current mover (3).
;
STR
	ld c,a			; save the screen position's lower byte
	ld l,c			; L= the screen position's lower byte
	ld h,BoardH1/256	; HL= the whole screen address
;
;	------------------------------------------------------------------
STR2
	ld a,l			; A= the screen position's lower byte
	ld b,$02		; B=2 indicates the margin of the board

	cp BoardH1 & 255	; if the address is smaller than the board's
	jr c,STR4		; first square, see the next possible move

	cp BrdOut & 255		; if the address is bigger than the board's
	jr nc,STR4		; last square, then see the next possible move

	ld a,(hl)		; the board position'c content
	and $7f			; deleting colour bit
	jr z,STR3		; empty square?

	cp $76			; right margin (N/L)?
	jr z,STR4		;

	cp $26			; left margin ?
	jr c,STR4		; (character code smaller than "A")

	ld a,(hl)		; colour bit back again
	inc b			; B=3 indicates own piece

MoverCol .equ $+1

	add a,$80		; the current mover's colour ($80 or $00)
	rla			; if it corresponds, the 7th bit
	jr nc,STR4		; is zero

        xor a                   ; set Z-flag
        ret                     ; A=0 indicates the opponent
STR3
        dec b                   ; B=1 indicates the empty square
STR4
	ld a,b			; A=B (1..3) position's properties
        and a                   ; reset Z-flag
	ret			;
;
;	--------------------------------- TABLES:
theKing
aRook
	.db $01,$0B,$FF,$F5
	;     1, 11, -1,-11
blkPawn	.equ $+1
aBishop
	.db $F6,$F4,$0C,$0A
	;   -10,-12, 12, 10
akNight
	.db $0D,$F3,$15,$EB,$17,$E9,$F7,$09
	;    13,-13, 21,-21, 23,-23, -9,  9
whtPawn	.equ $+2
	.db $0B,$0A,$0C
	;    11, 10, 12
;
;	--------------------------------- PIECES:
;
whK	.equ $30		; white King
whQ	.equ $36		; white Queen
whR	.equ $37		; white Rook
whB	.equ $27		; white Bishop
whN	.equ $33		; white kNight
whP	.equ $35		; white Pawn
;
;	---------------------------------
;
blK	.equ whK+$80		; black King
blQ	.equ whQ+$80		; black Queen
blR	.equ whR+$80		; black Rook
blB	.equ whB+$80		; black Bishop
blN	.equ whN+$80		; black kNight
blP	.equ whP+$80		; black Pawn
;
;	---------------------------------
;
#ifdef QPawn	; "Queen's Pawn Game"

QP1	.equ $80		;
QP2	.equ whP		;
KP1	.equ whP		;
KP2	.equ $80		;

#else		; "King's Pawn Game"

QP1	.equ whP		;
QP2	.equ $00		;
KP1	.equ $00		;
KP2	.equ whP		;

#endif
;
;	---------------------------------
whPieces
	;   $36,$37,$27,$33,$35,$30
	;    54, 55, 39, 51, 53, 48
	.db whQ,whR,whB,whN,whP,whK
;
;	------------------------------------------------------------------
;
; PSC: gives a score to a chess piece - Q(5), R(4), B(3), N(2), P(1), K(0)
;
PSC
	and $7f			; deleting the colour of the piece
	ld hl,whPieces		; the character codes of the pieces
	ld bc,$0006		; the highest value +1
        cpir                    ; search

	ld a,c			; Z=0 if there's no match 
	ret			; A=C
;
;	------------------------------------------------------------------
;
; AddList: adds to the current legal move list another entry on the end.
;
ALIST
	ld hl,newList		; the starting address of the list of moves
	inc (hl)		; increase the counter
	ld a,(hl)		; read the counter
	add a,l			; calculate the new address
	ld l,a			; set pointer
	ld (hl),c		; and store the new item
	ret	  		;
;
;	------------------------------------------------------------------
;
; PIECE: this sets up pointers to possible move tables and number of steps and
; directions.
;
PIECE
	ld e,l			; save the current position of the piece

	xor a			; clear the list 
	ld (newList),a		; of moves

	ld a,(hl)		; content of the current position 
	ld d,a			; store it

	call PSC		; is a piece? Q(5),R(4),B(3),N(2),P(1),K(0)
	ret nz			; no, return

	ld bc,$0801		; max. nr. of directions and moves
	ld hl,theKing		; pointer to the table of moves
	and a			; the "K"ing?
	jr z,MOVE		; creating list of moves

	ld l,blkPawn & 255	; pointer to the table of moves
	dec a			; is it a "P"awn?
	jr z,PAWN		; creating list of moves

	ld l,akNight & 255	; pointer to the table of moves
	dec a			; is it a k"N"ight?
	jr z,MOVE		; creating list of moves

	ld bc,$0408		; max. nr. of directions and moves
	ld l,aBishop & 255	; pointer to the table of moves
	dec a			; is it a "B"ishop?
	jr z,MOVE		; creating list of moves

	ld l,aRook & 255	; pointer to the table of moves
	dec a			; is it a "R"ook?
	jr z,MOVE		; creating list of moves

	ld b,c			; 8 directions and 8 moves
        			; the "Q"ueen
;
;	------------------------------------------------------------------
;
; MOVE: produces a list of all legal moves available to the piece under
; consideration.
;
MOVE
	ld a,e			; the current position of the piece
MOVE1
	add a,(hl)		; new position based on the table of moves
	push af			; save position
	push hl			; save table of movements' pointer
	push bc			; save max. number of moves and directions

	call STR		; analyse content

	cp $02			; if it's not empty (1) or not an opponent (0)
	jr nc,MOVE2		; then see the next possible move

	push af			; otherwise save position property
	call ALIST		; and add to the list of moves

	pop af			; set back the position property
	and a			; if it's an opponent, then we can't go in that direction
	jr z,MOVE2		; let's see the next possible move

	pop bc			; max. number of moves and the direction
	pop hl			; the pointer of table of moves
	ld a,c			; if this piece (in this direction)
	dec a			; can only move once (one square)
	jr z,MOVE3		; let's see the next possible direction

	pop af			; otherwise set back the address of the position
	jr MOVE1		; then calculate the next move
MOVE2
	pop bc			; max. number of moves and the direction
	pop hl			; the pointer of table of moves
MOVE3
	pop af			; set back the address of the position
	inc hl			; the next item of the table of moves
	djnz MOVE		; if it wasn't the last direction, then repeat from the beginning
	ret			;
;
;	------------------------------------------------------------------
;
; PAWN: produces a list of all possible legal moves including initial double moves.
;
PAWN
        bit 7,d                 ; the pawn's colour
	jr nz,PAWN1		; black?

	ld l,whtPawn & 255	; no - white pawn's table of moves
PAWN1
	ld d,$03		; can move to 3 different directions
PAWN2
	ld a,e			; the pawn's position (lower byte)
PAWN3
	add a,(hl)		; new position based on the table of moves
	push hl			; save pointer of the table of moves
	push af			; save position

	call STR		; analyse content
				; if it's an opponent,
	jr z,PAWN5		; then add to the list of moves

	dec a			; if it's not empty,
	jr nz,PAWN4		; then see the next direction

	ld a,d			; if it's not the
	dec a			; last direction (forward)
	jr nz,PAWN4		; see the next direction

	call ALIST		; otherwise add to the list of moves

	ld a,e			; the pawn's position (lower byte)

	cp wPwnMax & 255	; 2nd row? (white pawn's first move)
	jr c,PAWN6		; if yes, then let's see the next move

	cp bPwnMax & 255	; 7th row? (black pawn's first move)
	jr nc,PAWN6		; if yes, then let's see the next move
PAWN4
	pop af			; set back the address of the position
	pop hl			; the pointer of the table of moves
	dec hl			; set to the next direction
	dec d			; check the direction
	jr nz,PAWN2		; if it wasn't the last, then again
	
	ret     
;
;	------------------------------------------------------------------
PAWN5
	ld a,d			; if the direction is 
	dec a			; not the last (forward)
	call nz,ALIST		; then add to the list of moves

	jr PAWN4		; test the next direction
;
;	------------------------------------------------------------------
PAWN6
	pop af			; set back the address of the position
	pop hl			; the pointer of the table of moves
	ld e,a			; keep the positon's address
	jr PAWN3		; test the new position
;
; ======================================================================== 
; D-FILE
; ==============================================
;
DFile
	.db $76,$76,$76,$76,$76,$76,				; rows 1-5
	.db $A9,$B7,$AD,$76,$76,				; rows 6-7

CountA1	.equ $+9-11+$26
BoardH1	.equ $+2

	.db $1D,$08,whR,whN,whB,whK,whQ,whB,whN,whR,$76,	; row 8
	.db $1E,$08,whP,whP,whP,KP1,QP1,whP,whP,whP,$76,	; row 9

wPwnMax	.equ $-1

	.db $1F,$08,$00,$80,$00,KP2,QP2,$80,$00,$80,$76,	; row 10
	.db $20,$08,$80,$00,$80,$00,$80,$00,$80,$00,$76,	; row 11
	.db $21,$08,$00,$80,$00,$80,$00,$80,$00,$80,$76,	; row 12
	.db $22,$08,$80,$00,$80,$00,$80,$00,$80,$00,$76,	; row 13

bPwnMax	.equ $-1

	.db $23,$08,blP,blP,blP,blP,blP,blP,blP,blP,$76,	; row 14
	.db $24,$08,blR,blN,blB,blK,blQ,blB,blN,blR,$76,	; row 15

BrdSize	.equ $-BoardH1
BrdOut	.equ $-1

	.db $08,$08,$2D,$2C,$2B,$2A,$29,$28,$27,$26,$76,	; row 16-17
	.db $76,
INPUT
	.db $16,$16,$16,$16,$16,$76,				; row 18
	.db $76,$76,$76,$76,$76,$76				; rows 19-24
;
;	================================================================== 
;
origPos .equ $+1
PMOVE
	ld hl,BoardH1		; original position
	ld a,(de)		; the content of the new position
	ld c,a			; to the register "C"
	ld a,(hl)		; the content of the original position
	ld (hl),$00		; (deleting temporarily)
	ld (de),a		; to the new position
	ld b,a			; and to register "B"

	exx			; save the main register set
	and a			; CY=0
	call SHIFT		; save the list of moves
;
;	------------------------------------------------------------------
;
; CHK locates current mover's Kings and stores the position in the attack
; register.
;
CHK
	ld a,(MoverCol)		; current mover's colour: $80(black), $00(white)
	add a,whK		; code for the "K"ing
	ld hl,BoardH1		; the board's starting address
	ld b,a			; setting the counter (bc) for
	cpir			; search

	ld a,l			; 
	dec a			; the result
;
;	------------------------------------------------------------------
;
; SQuare ATtack: determines whether the opposition can attack the square in the
; attack register.
;
SQ_AT
	ld (RAttack),a		; save the position
	ld b,BrdSize & 255	; check upon the number of screenposition (max. 86)
	ld hl,BoardH1-1		; the board's starting address (-1)
SQ_AT1
	inc hl			; the next position
	push hl			; save it
	push bc			; save the counter
	call STR2		; analyse the content

	jr nz,SQ_AT3		; if not opponent, then next

        ex de,hl                ; (save HL)
	call CHGMV		; changing the colour of the mover for the check up
        ex de,hl                ; (restore HL)

	call PIECE		; creating the list of moves

	call CHGMV		; set back the colour of the mover
SQ_AT2
	call TL			; test the list
	jr z,SQ_AT3		; if empty, see the next position

RAttack	.equ $+1
				; is the address in the attack register
	cp BoardH1 & 255	; on the list?
	jr nz,SQ_AT2		; if not, see the next component on the list

	pop bc			; set back the counter
	pop hl			; in HL the address of the attacker
	scf			; CY=1 indicates that there's an attack
	ret			;
SQ_AT3
	pop bc			; set back the counter
	pop hl			; the screen position which was checked upon
	djnz SQ_AT1		; if the last position is safe as well

	and a			; CY=0 indicates that there's no attack
	ret			;
;
;	------------------------------------------------------------------
;
; INC determines whether a square is being attacked.
;
INC_
	ld a,l			; the lower byte of the address

	exx			; save the main register set

	call SQ_AT		; is this position under attack?
				; (CY=1, if yes)
	exx			; set back the main register set

	ld a,d			;
	ret			;
;
;	------------------------------------------------------------------
;
#ifdef FreeToUse
;
; ************************************************************************
; 142 SPARE BYTES  (-11 for the upgraded ZX80 version) (-2 for the cursor)
; ************************************************************************
;
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0

#ifndef ZX80upg

	.db 0,0,0,0,0,0,0,0,0,0,0
#endif
#ifndef ShowCursor

	.db 0,0
#endif

#endif
;
;	------------------------------------------------------------------
;
; SCORE provides a move score based on the following:
; first, the "To" position results in taking of a piece.
; Second, the "From" position is attacked.
; Third, the "To" position is attacked.
; Fourth, "To" enables the computer to obtain a check
; and finally the "From" position is defended.
;
; The current move score is then compared with the previous best and if this is
; superior, the move is saved as the best so far.
;
SCORE
	push hl			; save the original position's address
	push bc			; save the content of the positions (original/new)
	push de			; save the new position's address

	push hl			; save the original position's address
	push bc			; save the content of the positions (original/new)

        ld h,b                  ; store the content of the original position and the
        ld (oldScore+3),hl      ; address of the original position (lower byte), and
        ld (oldScore+1),de      ; store the new position's address, as score parameters

	call PSC		; value of the piece: Q(5), R(4), B(3), N(2), P(1)

	add a,h			; + $40 (64; whPieces upper byte)
	ld d,a			; saved in D

	pop af			; A= piece in the original position

	call PSC		; value of the piece: Q(5), R(4), B(3), N(2), P(1)

	pop hl			; set back the original position
	call INC_		; is this position under attack? (CY=1, if it is)

	jr nc,SCORE1		;

	add a,c			; if it is, then change the value of the move
SCORE1
	pop hl			; reading the address of the new position and
	pop de			; the original(D)/new(E) content
				; content of the new position
	ld (hl),d		; changed to the content of the original position
	push hl			; save the address of the new position
	push de			; save the content of the positions (original/new)

	ld d,a			; and save it to a temporary repertory

	call INC_		; is the new position under attack? (CY=1, if it is)

	jr nc,SCORE2		;

	sub c			; if yes, then set back the previous value of the move
SCORE2
	push af			; save the calculated value of the move

	call CHGMV		; changing the colour of the mover

	call CHK		; check?

	pop bc			; (calculated value to register "B")
	jr nc,SCORE3		;

	inc b			; if yes, then increase the value of the move
	inc b			; by 2
SCORE3
	pop de			; reading the original(D)/new(E) content
	pop hl			; set back the content of
	ld (hl),e		; the new position

	pop hl			; change the colour of the 
	call CHG		; original position

	call INC_		; is this position under attack? (CY=1, if it is)

	jr nc,SCORE4		;
	dec b			; if it is, then lower the value of the move
SCORE4
	call CHG		; set back the colour of the position

	call CHGMV		; set back the colour of the mover

	ld a,b			; save the calculated value of the
	ld de,oldScore		;
	ld (de),a		; move
	ld hl,newScore		; if the previously calculated
	cp (hl)			; value is smaller,
	ret c			;

	ld bc,$0005		; then copy the data of the new position
	jr SHIFT1		; as a replacement for the old data
;
;	------------------------------------------------------------------
;
; Shift moves the current move list to a safe position whilst Check is being
; evaluated, and then recovers the move list on completion. It is also used to
; shift the best move so far up into the move list.
;
SHIFT
	ld hl,oldList		; address of the saved list
	ld de,newList		; address of the list of moves
	ld bc,$001c		; max. 28 bytes
	jr c,SHIFT2		; if CY=1, then set back
SHIFT1
	ex de,hl		; if CY=0, then save
SHIFT2
	ldir			; moving the data
	ret			;
;
;	------------------------------------------------------------------
;
; MPSCAN: scans the board for computer pieces and, using move and score,
; determines all legal moves and saves the best.
;
MPSCAN
	xor a			; initialise (to zero) the
	ld (newScore),a		; calculated value of the move

	ld b,BrdSize & 255	; we look through max. 86 positions
	ld hl,BoardH1-1		; starting with the board's first component
MPSCAN1
	inc hl			; pointer to the next position on the board
	push hl			; save the position on the board
	push bc			; save the counter
	call STR2		; analyse content

	cp $03			; is it our own piece?
	jr nz,MPSCAN5		; if not, then check the next position

	ld (origPos),hl		; save the position
	call PIECE		; creating list of moves
MPSCAN2
	call TL			; a component of the list
	jr z,MPSCAN5		; if empty, then check the next position

	ld e,a			; a possible new position for the piece
	ld d,BoardH1/256	; 
	call PMOVE		; move the piece
				; save the list of moves
				; check? (is the king under attack?)
	exx			; set back the main register set

	ld (hl),b		; set back the content of the original position
	ld a,c			; and
	ld (de),a		; the content of the new position
				; if the king isn't under attack
	call nc,SCORE		; choose the best possible move

	scf			; CY=1
	call SHIFT		; set back of the list of moves
	jr MPSCAN2		; the next component of the list of moves
MPSCAN5
	pop bc			; the current value of the counter and
	pop hl			; the position on the board
	djnz MPSCAN1		; next position

	ld a,(newScore)		; this was the last position
	and a			; checking the result

#ifdef ZX80upg

	jp z,GameOver		; if the value of the move is zero, then the game ends
#else
MPSCAN6
	jr z,MPSCAN6		; if the value of the move is zero, then the game ends
#endif
	ld de,(newScore+3)	; original content(D) / position(E)
	ld hl,(newScore+1)	; the address of the new position
        ld (hl),d               ; original content to the new position (move)
        ld l,e                  ; the address of the original position
;
;	------------------------------------------------------------------
CHGSQ
	bit 0,l			; the even-numbered squares
	ld (hl),$80		; are black
	call nz,CHG             ; the odd ones are white
;
;	------------------------------------------------------------------
CHGMV
	ld hl,MoverCol		; the colour of the mover
;
;	------------------------------------------------------------------
CHG
	ld a,(hl)		; changing the
	add a,$80		; colour of a piece
	ld (hl),a		; or position
	ret			;
;
;	------------------------------------------------------------------
DRIVER4
	ld (hl),b		; move the piece to the original position 
	ld a,c			; set back the original value of the new position
	ld (de),a		; 
;
; ************************************************************************
;
; DRIVER:
; Main control logic, uses all the other subroutines to provide program control.
;
DRIVER
	ld bc,$0516		; the INPUT line consists of 5 "-" character
	ld hl,INPUT+5		; end of the INPUT LINE (+1)
DRIVER1
	dec hl			; 
	ld (hl),c		; fill the INPUT line 
	djnz DRIVER1		; 

	call KYBD		; get and check the "from" position

	cp $03			; is it our own piece?
	jr nz,DRIVER		; if not, then from the beginning

	ld (origPos),hl		; save the "from" position
	call PIECE		; creating the list of moves

	ld hl,INPUT+3		; 
	call KYBD		; get and check the target position

	cp $02			; if not empty, or
	ex de,hl		; not one of the pieces of the opponent,
	jr nc,DRIVER		; then from the beginning
DRIVER2
	call TL			; testing the list
	jr z,DRIVER		; if empty, then from the beginning

	cp c			; is it on the list?
	jr nz,DRIVER2		; if not, see the next item of the list

	call PMOVE		; move piece to the new position

	exx			; set back the main register set
	jr c,DRIVER4		; cancel the move, if the king is under attack

	call CHGSQ		; setting of the colours of the old position and
				; changing the colour of the mover
	call MPSCAN		; ZEDDY moves

	jr DRIVER		; USER moves
;
;	------------------------------------------------------------------
;
newList .equ $			; the max. value: $439A (17306)
oldList .equ $+28		; $43d2(bottom of the deepest stack) - 2*28
;
; ************************************************************************
;	MAIN PROGRAM ENTRY (RAND USR X)
; ************************************************************************
;
START
        ld sp,$4400             ; SP points the top of RAM (1K)
;
;	------------------------------------------------------------------
;
	.db $21		 	; MC "ld hl,NN"
	.db $21		 	; 1st 2 bytes of
	.db newList & 255 	; "ld hl,newList"
	ld (TL),hl		;
	;
	ld a,$7E		; MC "ld a,(hl)"
	ld (TL1),a		;
	;
	.db $21		 	; MC "ld hl,NN"
	.db $85		 	; MC "add a,l"
	.db $6F		 	; MC "ld l,a"
	ld (TL2),hl		;
;
;	------------------------------------------------------------------ 
;
        jr DRIVER               ; 
;
; ==============================================   
; LINE 3 RAND USR X
; ==============================================   
;
Line3
	.db $00,$03		; line number
	.dw Variables-L3Text	; line length 
L3Text
	.db $F9,$D4,$3D		; RAND USR X
	.db $76			; line end (halt)
;
; ==============================================
; VARIABLES
; ==============================================
;
;;dblDRV	.equ (2*DRIVER)& $7FFF

dblVAL	.equ (2*START)& $7FFF 
Variables
	.db $7D,$8F		; ($7D,$8F,$04,$7E,$00,$00)
;;	.db dblDRV/256		;
;;	.db dblDRV&255		;
	.db dblVAL/256		;
	.db dblVAL&255		; 
	.db $00,$00		; X=START

	.db $80
eof_Vars
.end

